/// @file
/// A TLM task.

#include <sstream>

//#include "TlmTaskProxy_t.hh"
#include "MyTaskSender.hh"


//using Scnsl::Tlm::TlmTask_if_t;


// ////////////////////////////////////////////////////////////////
// Constructor.
// ////////////////////////////////////////////////////////////////

MyTaskSender::MyTaskSender( sc_core::sc_module_name modulename,
                            const task_id_t id,
                            Scnsl::Core::Node_t * n,
                            const size_t proxies,
							label_t label,
							const size_t pktSize,
			  				const sc_core::sc_time genTime,
							const sc_core::sc_time on,
							const sc_core::sc_time off )
    throw ( std::invalid_argument ):
    // Parents:
    Scnsl::Traffic::OnOff_t( modulename, id, n, proxies, label, pktSize, genTime, on, off )
{
	SC_THREAD( writingProcess );
}


MyTaskSender::~MyTaskSender() throw (){}


void MyTaskSender::writingProcess()
{

	OnOff_t::enable();
	wait(200, sc_core::SC_MS);
	OnOff_t::disable();
	wait(400, sc_core::SC_MS);
	OnOff_t::enable();

}


