// Copyright (C) 2008
// by all contributors.

// This file is part of SCNSL.

// SCNSL is free software:
// you can redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option)
// any later version.

// SCNSL is distributed in the hope
// that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.
// See the GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with SCNSL,
// in a file named LICENSE.txt.
// If not, see <http://www.gnu.org/licenses/>.



/// @file
/// TLM base types.



#include "tlm_data_types.hh"


namespace Scnsl{ namespace Tlm {



// ////////////////////////////////////////////////////////////////
// Constants.
// ////////////////////////////////////////////////////////////////

const tlm_command_t PACKET_COMMAND = tlm::TLM_READ_COMMAND;

const tlm_command_t CARRIER_COMMAND = tlm::TLM_WRITE_COMMAND;

	}
}
