// Copyright (C) 2008
// by all contributors.

// This file is part of SCNSL.

// SCNSL is free software:
// you can redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option)
// any later version.

// SCNSL is distributed in the hope
// that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.
// See the GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with SCNSL,
// in a file named LICENSE.txt.
// If not, see <http://www.gnu.org/licenses/>.



/// @file
/// The Environment interface.



#include "Environment_if_t.hh"

//
using Scnsl::Utils::Environment_if_t;

Environment_if_t* Environment_if_t::_env = NULL;

// ////////////////////////////////////////////////////////////////
// Destructor.
// ////////////////////////////////////////////////////////////////

Environment_if_t::~Environment_if_t()
  
{
    // Nothing to do.
}

Environment_if_t::Environment_if_t()
        
        {
        
        }

Environment_if_t* Environment_if_t::getInstance() {
    if(Environment_if_t::_env == NULL){
        Environment_if_t::_env = new Environment_if_t();
       
    }

    return Environment_if_t::_env;
}

double Environment_if_t::getReceiverPower( const node_properties_t & /*sp*/,
    const node_properties_t & /*rp*/){

   

    return 1;

}

double Environment_if_t::getMaxDelay( const node_properties_t & /*sp*/,
    const node_properties_t & /*rp*/)
{
    return 1;

}

double Environment_if_t::getBitErrorRate(const node_properties_t & /*sp*/,
    const node_properties_t & /*rp*/)
{
    return 1;
}

Scnsl::Core::propagation_t Environment_if_t::getPropagation(){
    return 1;
}

// ////////////////////////////////////////////////////////////////
// Interface methods.
// ////////////////////////////////////////////////////////////////
/*
Environment_if_t::Environment_if_t( const Environment_if_t & e )
            throw ()
            {
            
            }

        /// @brief Assignment operator.
        Environment_if_t::Environment_if_t & operator = ( const Environment_if_t & e )
            throw ()
            {
                return *this;
            }
            */
